diff --git a/encoder/encoder.c b/encoder/encoder.c
index 6fd8838..97a3449 100644
--- a/encoder/encoder.c
+++ b/encoder/encoder.c
@@ -2317,8 +2317,13 @@ int     x264_encoder_encode( x264_t *h,
 
         fenc->i_frame = h->frames.i_input++;
 
-        if( h->frames.i_bframe_delay && fenc->i_frame == h->frames.i_bframe_delay )
-            h->frames.i_bframe_delay_time = fenc->i_pts;
+        if( h->frames.i_bframe_delay )
+        {
+            if ( fenc->i_frame == 0 )
+                h->frames.i_bframe_delay_time = fenc->i_pts;
+            if ( fenc->i_frame == h->frames.i_bframe_delay )
+                h->frames.i_bframe_delay_time = fenc->i_pts - h->frames.i_bframe_delay_time;
+        }
 
         if( h->param.b_vfr_input && fenc->i_pts <= h->frames.i_largest_pts )
             x264_log( h, X264_LOG_WARNING, "non-strictly-monotonic PTS\n" );
diff --git a/x264.h b/x264.h
index 683a024..d59ebda 100644
--- a/x264.h
+++ b/x264.h
@@ -625,7 +625,7 @@ typedef struct
     int     b_keyframe;
     /* In: user pts, Out: pts of encoded picture (user)*/
     int64_t i_pts;
-    /* Out: frame dts. Since the pts of the first frame is always zero,
+    /* Out: frame dts. When the pts of the first frame is close to zero,
      *      initial frames may have a negative dts which must be dealt with by any muxer */
     int64_t i_dts;
     /* In: custom encoding parameters to be set from this frame forwards
